'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getDeps;

var _globby = require('globby');

var _globby2 = _interopRequireDefault(_globby);

var _konan = require('konan');

var _konan2 = _interopRequireDefault(_konan);

var _utils = require('./utils');

var _pkgError = require('./pkg-error');

var _pkgError2 = _interopRequireDefault(_pkgError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getDeps(input) {
  const files = _globby2.default.sync([...input, '!**/node_modules/**']);
  const allDeps = [];
  files.forEach(file => {
    if ((0, _utils.isFile)((0, _utils.cwd)(file))) {
      allDeps.push(getFileDeps((0, _utils.cwd)(file)));
    }
  });
  return Promise.all(allDeps).then(results => {
    const pkgs = new Set(results.reduce((a, b) => a.concat(b), []));
    if ([...pkgs].length === 0) {
      return Promise.reject(new _pkgError2.default('no pkgs to install'));
    }
    return [...pkgs];
  });
}

function getFileDeps(file) {
  const regex = new RegExp(/^[a-zA-Z][^/]+/);
  const content = (0, _utils.readFile)(file);
  let deps = (0, _konan2.default)(content).filter(pkg => pkg.match(regex));
  deps = deps.map(pkg => pkg.match(regex)[0]);
  return Promise.resolve(deps);
}